{------------------------------------------------------------------------------}
{
   Unit Name: AmpariForm
   Purpose  : Nesteen kaataminen mrist toiseen
   Author   : Vesa Lappalainen
   Date     : 6.12.2000
   Changed  :

   Pelill demonstroidaan/harjoitellaan miten voidaan kahdella astialla,
   5 l ja 8 l,  muodostaa kaikki mahdolliset tilavuudet 1-13 l.
   Peliss on kaksi varsinaista astiaa: a5 ja a8, sek kolmas apuastia
   a0.  Nestett voidaan kerrallaan kaataa yhdest astiasta toiseen
   joko siten, ett astian koko sislt tyhjennetn jos se mahtuu
   tai astista kaadetaan sen verran ett toinen astia tulee tyteen.

   Ensin klikataan sit astiaa, josta kaadetaan ja sitten sit
   astiaa, johon kaadetaan.

   Peli kirjoittaa "siirroista" logia teksti-ikkunaan MemoOhjeet.
   Esim. 3 litraa saadaan "ohjeikkunan syntaksin" mukaisesti kuvattuna:
     a0 -> a8: 0.0 8.0
     a8 -> a5: 5.0 3.0
   Eli kaadetaan a0 astiasta (tyhjn) a8 astiaan niin ett a8 tulee
   tyteen.  Tllin astioissa a5 ja a8 on 0 ja 8 l nestett.
   Sitten kaadetaan a8 astiasta a5 astia tyteen, jolloin a8 astiaan
   j kaivattu 3 l nestett.

   Peliss on mys nappulat, joissa on tekstit 1,2,3...,12,13.
   Aina kun jokin nestemr on joko astiassa a5 tai a8 tai
   nestemr on yhteens astioissa a5 ja a8, saa vastaavan nappulan
   "klikata" pois.  Edellisess esimerkiss saisi painaa nappuloita
   3, 5 ja 8 (kaikki em. nestemrt on saatavissa

   Tehtvi:
   0) Kommentoi tarkasti metodit AstiaClick, ButtonClick ja
      FormCreate
   1) Lis peliin loppumisen tarkistus, eli kun kaikki nappulat
      on merkitty (enabled := false), niin tulee ilmoitus pelin
      loppumisesta ja siirtojen mrst ( MemoOhjeet.Lines.Count).
   2) Lis peliin kyttytyminen, jossa kaikki oikeatkin nappulat
      muuttuvat takaisin aktiivisiksi jos kerrankin painetaan
      vr nappulaa.  Esim. jos astioiden tilavuudet ovat 3 ja 5
      ja painetaan nappulaa 4, niin kaille nappuloille tulee
      Enabled := True.
   3) Nyt nappulat on sijoitettu formin luonnissa kaikki rinnakkain.
      Mit koodista pitisi muuttaa ja miten, jos nappulat olisikin
      sijoitettu paikalleen jo suunnitteluaikana "raahaamalla"?
   4) Kuinka montaa rivi peliss pitisi nyt muuttaa, jotta
      voitaisiin "leikki" astoilla 2l ja 3l?
   5) Muuta peli automaattiseksi siten, ettei nappuloita tarvitse
      itse kyd painelemassa, vaan nappulat tarkistetaan
      "automaattisesti" kunkin siirron jlkeen.

}
{------------------------------------------------------------------------------}

unit AmpariForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  astia, ExtCtrls, StdCtrls;

type
  TFormAmpari = class(TForm)
    PanelButtons: TPanel;
    MemoOhjeet: TMemo;
    LabelA5: TLabel;
    LabelA8: TLabel;
    LabelA0: TLabel;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    a5 : TAstia;
    a8 : TAstia;
    a0 : TAstia;
    MistaOtetaan : TAstia;
    btns : array of TButton;
    procedure AstiaClick(Sender: TObject);
    procedure ButtonClick(Sender: TObject);
    procedure AstiaEvent(sender:TAstia; const viesti:string);
    function GetAineetAsString: string;
  public
    property AineetAsString : string read GetAineetAsString;
  end;

var
  FormAmpari: TFormAmpari;

implementation

{$R *.DFM}

procedure TFormAmpari.AstiaClick(Sender: TObject);
var KlikattuAstia : TAstia;
begin
  if not ( Sender is TAstia ) then exit;
  KlikattuAstia := TAstia(sender);
  if ( MistaOtetaan = nil ) then begin
    MistaOtetaan := KlikattuAstia;
    exit;
  end;

  KlikattuAstia.Kaada(MistaOtetaan);
  MistaOtetaan := nil;
end;


procedure TFormAmpari.AstiaEvent(sender: TAstia; const viesti: string);
begin
  MemoOhjeet.Lines.Add(viesti + ': ' + AineetAsString);
end;

procedure TFormAmpari.ButtonClick(Sender: TObject);
var b : TButton;
  function Tutki(d:double):boolean;
  begin
    Result := false;
    if  not ( eq(b.Tag,d) ) then exit;
    b.Enabled := false;
    Result := true;
  end;
begin
  if not ( sender is TButton ) then exit;
  b := TButton(sender);
  if ( tutki(a5.Ainetta) ) then exit;
  if ( tutki(a8.Ainetta) ) then exit;
  if ( tutki(a5.Ainetta+a8.Ainetta) ) then exit;

end;

procedure TFormAmpari.FormCreate(Sender: TObject);
// Kun lomake luodaan, luodaan dynaamisesti astiat ja nappulat.
var i,max_tilavuus:integer;

  function LuoAstia(V:double; lab : TLabel) : TAstia;
  var h : integer; a : TAstia;
  begin
    a := TAstia.Create(self);    a.Parent := self;
    a.Name := Format('a%1.0f',[V]);   // => esim. a.Name := 'a5';
    lab.Caption := a.Name;
    if ( V = 0 ) then V := max_tilavuus+1;
    h := Round(V*10);
    a.SetBounds(lab.Left,lab.Top-h,lab.Width,h);
    a.Tilavuus := V;
    a.OnClick := AstiaClick;
    a.OnFull := AstiaEvent;
    a.OnEmpty := AstiaEvent;
    Result := a;
  end;

begin
  a5 := LuoAstia(5,LabelA5);
  a8 := LuoAstia(8,LabelA8);
  max_tilavuus := Round(a5.Tilavuus + a8.Tilavuus);

  a0 := LuoAstia(0,LabelA0);
  a0.Ainetta  := max_tilavuus;
  SetLength(btns,max_tilavuus+1);

  for i:=1 to max_tilavuus do begin
    btns[i] := TButton.Create(self); btns[i].Parent := PanelButtons;
    btns[i].Caption := IntToStr(i);
    btns[i].Width := 30;  btns[i].Left := 1000; btns[i].Align := alLeft;
    btns[i].OnClick := ButtonClick;
    btns[i].Tag := i;
  end;

end;

function TFormAmpari.GetAineetAsString: string;
// Palauttaa astoiden sislln merkkijonona, esim: 3.0 5.0
begin
  Result := Format('%3.1f %3.1f',[a5.Ainetta,a8.Ainetta]);
end;

end.
